<?php

if ( $this->legacy_mode ) {
	// Menu Settings
	$this->sections[] = $this->add_customizer_field(
		array(
			'icon'       => 'Simple-Line-Icons-menu',
			'icon_class' => '',
			'title'      => __( 'Menu', 'porto' ),
			'transport'  => 'postMessage',
			'fields'     => array(
				array(
					'id'    => 'desc_info_menu_notice',
					'type'  => 'info',
					'desc'  => wp_kses(
						/* translators: %s: Builder url */
						sprintf( __( '<strong>Important Note:</strong> <a href="%1$s" target="_blank">Header</a> Builder helps you to develop your site easily. If you use builder, some options might be overrided by Menu widget.', 'porto' ), $header_url ),
						array(
							'strong' => array(),
							'b'      => array(),
							'a'      => array(
								'href'   => array(),
								'target' => array(),
								'class'  => array(),
							),
						)
					),
					'class' => 'porto-important-note',
				),
				array(
					'id'      => 'menu-type',
					'type'    => 'image_select',
					'title'   => __( 'Main Menu Type', 'porto' ),
					'options' => array(
						''                           => array( 
							'title' => __( 'Normal', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-normal.svg',
						),
						'menu-flat'                  => array(
							'title' => __( 'Flat', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-flat.svg',
						),
						'menu-flat menu-flat-border' => array(
							'title' => __( 'Flat & Border', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-flat-border.svg',
						),
						'menu-hover-line'            => array(
							'title' => __( 'Top Border on hover', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-hover-line.gif',
						),
						'menu-hover-line menu-hover-underline' => array(
							'title' => __( 'Thick Underline on hover', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-hover-underline.gif',
						),
						'overlay'                    => array(
							'title' => __( 'Popup', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-overlay.svg',
						),
					),
					'default' => '',
				),
				array(
					'id'       => 'menu-arrow',
					'type'     => 'switch',
					'title'    => __( 'Show Menu Arrow', 'porto' ),
					'desc'     => __( 'If menu item has children, show arrow in first-level menu item.', 'porto' ),
					'default'  => false,
					'on'       => __( 'Yes', 'porto' ),
					'off'      => __( 'No', 'porto' ),
					'required' => array( 'menu-type', 'equals', array( '', 'menu-flat', 'menu-flat menu-flat-border', 'menu-hover-line', 'menu-hover-line menu-hover-underline' ) ),
				),
				array(
					'id'       => 'submenu-arrow',
					'type'     => 'switch',
					'title'    => __( 'Show triangle in dropdown', 'porto' ),
					'desc'     => __( 'Show triangle arrow to the menu popup.', 'porto' ),
					'default'  => false,
					'on'       => __( 'Yes', 'porto' ),
					'off'      => __( 'No', 'porto' ),
					'required' => array( 'menu-type', 'equals', array( '', 'menu-flat', 'menu-flat menu-flat-border', 'menu-hover-line', 'menu-hover-line menu-hover-underline' ) ),
				),
				array(
					'id'     => 'desc_info_side_header',
					'type'   => 'info',
					'title'  => __( 'When using Side header type or showing Main Menu in Sidebar', 'porto' ),
					'notice' => false,
				),
				array(
					'id'        => 'side-menu-type',
					'type'      => 'image_select',
					'title'     => __( 'Sidebar Menu Type', 'porto' ),
					'desc'      => __( 'Controls how to show its submenus.', 'porto' ),
					'options'   => array(
						''          => array(
							'title' => __( 'Normal', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-normal.svg',
						),
						'accordion' => array(
							'title' => __( 'Accordion Menu', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-accordion.svg',
						),
						'slide'     => array(
							'title' => __( 'Horizontal Slide Menu', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-slide.svg',
						),
						'columns'   => array(
							'title' => __( 'Horizontal Columns', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-columns.svg',
						),
					),
					'default'   => '',
					'transport' => 'refresh',
				),
				array(
					'id'       => 'menu-sidebar-title',
					'type'     => 'text',
					'title'    => __( 'Sidebar Menu Title', 'porto' ),
					'subtitle' => __( 'Input the title of sidebar menu.', 'porto' ),
					'default'  => __( 'All Department', 'porto' ),
				),
				array(
					'id'        => 'menu-sidebar',
					'type'      => 'switch',
					'title'     => __( 'Show Main Menu in Sidebar', 'porto' ),
					'desc'      => __( 'If the layout of a page is left sidebar or right sidebar, the main menu shows in the sidebar.', 'porto' ),
					'default'   => false,
					'on'        => __( 'Yes', 'porto' ),
					'off'       => __( 'No', 'porto' ),
					'transport' => 'refresh',
				),
				array(
					'id'       => 'menu-sidebar-toggle',
					'type'     => 'switch',
					'title'    => __( 'Toggle Sidebar Menu', 'porto' ),
					'subtitle' => __( 'Add a toggle button of the sidebar menu.', 'porto' ),
					'required' => array( 'menu-sidebar', 'equals', true ),
					'default'  => false,
					'on'       => __( 'Yes', 'porto' ),
					'off'      => __( 'No', 'porto' ),
				),
				array(
					'id'        => 'menu-sidebar-home',
					'type'      => 'switch',
					'title'     => __( 'Show Main Menu in Sidebar only on Home', 'porto' ),
					'subtitle'  => __( 'You can see sidebar menu only on homepage.', 'porto' ),
					'required'  => array( 'menu-sidebar', 'equals', true ),
					'default'   => true,
					'on'        => __( 'Yes', 'porto' ),
					'off'       => __( 'No', 'porto' ),
					'transport' => 'refresh',
				),
				array(
					'id'     => 'desc_info_header_preset1',
					'type'   => 'info',
					'title'  => __( 'If header type is 1, 4, 13, 14 or header builder', 'porto' ),
					'notice' => false,
				),
				array(
					'id'      => 'menu-align',
					'type'    => 'button_set',
					'title'   => __( 'Main Menu Align', 'porto' ),
					'options' => array(
						''         => __( 'Left', 'porto' ),
						'centered' => __( 'Center', 'porto' ),
					),
					'default' => '',
				),
				array(
					'id'     => 'desc_info_header_preset2',
					'type'   => 'info',
					'title'  => __( 'If header type is 9 or header builder', 'porto' ),
					'notice' => false,
				),
				array(
					'id'       => 'menu-title',
					'type'     => 'text',
					'title'    => __( 'Main Toggle Menu Title', 'porto' ),
					'subtitle' => __( 'If you use toggle menu like shop 35, please input the title of menu.', 'porto' ),
					'default'  => __( 'All Department', 'porto' ),
				),
				array(
					'id'        => 'menu-toggle-onhome',
					'type'      => 'switch',
					'title'     => __( 'Toggle on home page', 'porto' ),
					'desc'      => __( 'In homepage, a toggle menu is collapsed at first. Then it works as a toggle....', 'porto' ),
					'default'   => false,
					'on'        => __( 'Yes', 'porto' ),
					'off'       => __( 'No', 'porto' ),
					'transport' => 'refresh',
				),
				array(
					'id'     => 'desc_info_header_preset3',
					'type'   => 'info',
					'title'  => __( 'If header type is 1, 3, 4, 9, 13, 14 or header builder', 'porto' ),
					'notice' => false,
				),
				array(
					'id'      => 'menu-block',
					'type'    => 'textarea',
					'title'   => __( 'Menu Custom Content', 'porto' ),
					'desc'    => __( 'example: &lt;span&gt;Custom Message&lt;/span&gt;&lt;a href="#"&gt;Special Offer!&lt;/a&gt;&lt;a href="#"&gt;Buy this Theme!&lt;em class="tip hot"&gt;HOT&lt;/em&gt;&lt;/a&gt;', 'porto' ),
					'default' => '',
				),
			),
		),
		$options_style
	);
} else {
	$this->sections[] = $this->add_customizer_field(
		array(
			'icon'       => 'Simple-Line-Icons-menu',
			'icon_class' => '',
			'title'      => __( 'Menu', 'porto' ),
			'transport'  => 'postMessage',
			'fields'     => array(
				array(
					'id'    => 'desc_info_menu_notice',
					'type'  => 'info',
					'desc'  => wp_kses(
						/* translators: %s: Builder url */
						sprintf( __( '<strong>Important Note:</strong> <a href="%1$s" target="_blank">Header</a> Builder helps you to develop your site easily. If you use builder, some options might be overrided by Menu widget.', 'porto' ), $header_url ),
						array(
							'strong' => array(),
							'b'      => array(),
							'a'      => array(
								'href'   => array(),
								'target' => array(),
								'class'  => array(),
							),
						)
					),
					'class' => 'porto-important-note',
				),
				array(
					'id'      => 'menu-type',
					'type'    => 'image_select',
					'title'   => __( 'Main Menu Type', 'porto' ),
					'options' => array(
						''                           => array( 
							'title' => __( 'Normal', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-normal.svg',
						),
						'menu-flat'                  => array(
							'title' => __( 'Flat', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-flat.svg',
						),
						'menu-flat menu-flat-border' => array(
							'title' => __( 'Flat & Border', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-flat-border.svg',
						),
						'menu-hover-line'            => array(
							'title' => __( 'Top Border on hover', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-hover-line.gif',
						),
						'menu-hover-line menu-hover-underline' => array(
							'title' => __( 'Thick Underline on hover', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-hover-underline.gif',
						),
						'overlay'                    => array(
							'title' => __( 'Popup', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/menu-overlay.svg',
						),
					),
					'default' => '',
				),
				array(
					'id'       => 'menu-arrow',
					'type'     => 'switch',
					'title'    => __( 'Show Menu Arrow', 'porto' ),
					'desc'     => __( 'If menu item has children, show arrow in first-level menu item.', 'porto' ),
					'default'  => false,
					'on'       => __( 'Yes', 'porto' ),
					'off'      => __( 'No', 'porto' ),
					'required' => array( 'menu-type', 'equals', array( '', 'menu-flat', 'menu-flat menu-flat-border', 'menu-hover-line', 'menu-hover-line menu-hover-underline' ) ),
				),
				array(
					'id'       => 'submenu-arrow',
					'type'     => 'switch',
					'title'    => __( 'Show triangle in dropdown', 'porto' ),
					'desc'     => __( 'Show triangle arrow to the menu popup.', 'porto' ),
					'default'  => false,
					'on'       => __( 'Yes', 'porto' ),
					'off'      => __( 'No', 'porto' ),
					'required' => array( 'menu-type', 'equals', array( '', 'menu-flat', 'menu-flat menu-flat-border', 'menu-hover-line', 'menu-hover-line menu-hover-underline' ) ),
				),
				array(
					'id'     => 'desc_info_side_header',
					'type'   => 'info',
					'title'  => __( 'When using Side header type or showing Main Menu in Sidebar', 'porto' ),
					'notice' => false,
				),
				array(
					'id'        => 'side-menu-type',
					'type'      => 'image_select',
					'title'     => __( 'Sidebar Menu Type', 'porto' ),
					'desc'      => __( 'Controls how to show its submenus.', 'porto' ),
					'options'   => array(
						''          => array(
							'title' => __( 'Normal', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-normal.svg',
						),
						'accordion' => array(
							'title' => __( 'Accordion Menu', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-accordion.svg',
						),
						'slide'     => array(
							'title' => __( 'Horizontal Slide Menu', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-slide.svg',
						),
						'columns'   => array(
							'title' => __( 'Horizontal Columns', 'porto' ),
							'img'   => PORTO_OPTIONS_URI . '/svg/sidemenu-columns.svg',
						),
					),
					'default'   => '',
					'transport' => 'refresh',
				),
				array(
					'id'       => 'menu-sidebar-title',
					'type'     => 'text',
					'title'    => __( 'Sidebar Menu Title', 'porto' ),
					'subtitle' => __( 'Input the title of sidebar menu.', 'porto' ),
					'default'  => __( 'All Department', 'porto' ),
				),
				array(
					'id'        => 'menu-sidebar',
					'type'      => 'switch',
					'title'     => __( 'Show Main Menu in Sidebar', 'porto' ),
					'desc'      => __( 'If the layout of a page is left sidebar or right sidebar, the main menu shows in the sidebar.', 'porto' ),
					'default'   => false,
					'on'        => __( 'Yes', 'porto' ),
					'off'       => __( 'No', 'porto' ),
					'transport' => 'refresh',
				),
				array(
					'id'       => 'menu-sidebar-toggle',
					'type'     => 'switch',
					'title'    => __( 'Toggle Sidebar Menu', 'porto' ),
					'subtitle' => __( 'Add a toggle button of the sidebar menu.', 'porto' ),
					'required' => array( 'menu-sidebar', 'equals', true ),
					'default'  => false,
					'on'       => __( 'Yes', 'porto' ),
					'off'      => __( 'No', 'porto' ),
				),
				array(
					'id'        => 'menu-sidebar-home',
					'type'      => 'switch',
					'title'     => __( 'Show Main Menu in Sidebar only on Home', 'porto' ),
					'subtitle'  => __( 'You can see sidebar menu only on homepage.', 'porto' ),
					'required'  => array( 'menu-sidebar', 'equals', true ),
					'default'   => true,
					'on'        => __( 'Yes', 'porto' ),
					'off'       => __( 'No', 'porto' ),
					'transport' => 'refresh',
				),
				array(
					'id'        => 'menu-toggle-onhome',
					'type'      => 'switch',
					'title'     => __( 'Toggle on home page', 'porto' ),
					'desc'      => __( 'In homepage, a toggle menu is collapsed at first. Then it works as a toggle....', 'porto' ),
					'default'   => false,
					'on'        => __( 'Yes', 'porto' ),
					'off'       => __( 'No', 'porto' ),
					'transport' => 'refresh',
				),
				array(
					'id'       => 'menu-title',
					'type'     => 'text',
					'title'    => __( 'Main Toggle Menu Title', 'porto' ),
					'subtitle' => __( 'If you use toggle menu like shop 35, please input the title of menu.', 'porto' ),
					'default'  => __( 'All Department', 'porto' ),
				),
			),
		),
		$options_style
	);
}

if ( $this->legacy_mode ) {
	$this->sections[] = array(
		'id'         => 'skin-main-menu',
		'icon_class' => 'icon',
		'subsection' => true,
		'title'      => __( 'Menu Styling', 'porto' ),
		'transport'  => 'postMessage',
		'fields'     => array(
			array(
				'id'       => 'mainmenu-wrap-bg-color',
				'type'     => 'color',
				'title'    => __( 'Main Menu Wrapper Background Color', 'porto' ),
				'subtitle' => __( 'if header type is 1, 4, 9, 13, 14, 17 or header builder which contains main menu in header bottom section.', 'porto' ),
				'default'  => 'transparent',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-wrap-bg-color-sticky',
				'type'     => 'color',
				'title'    => __( 'Main Menu Wrapper Background Color in Sticky Header', 'porto' ),
				'subtitle' => __( 'if header type is 1, 4, 9, 13, 14, 17 or header builder which contains main menu in header bottom section.', 'porto' ),
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-wrap-padding',
				'type'     => 'spacing',
				'mode'     => 'padding',
				'title'    => __( 'Menu Menu Wrapper Padding', 'porto' ),
				'subtitle' => __( 'if header type is 1, 4, 9, 13, 14, 17 or header builder which contains main menu in header bottom section.', 'porto' ),
				'default'  => array(
					'padding-top'    => 0,
					'padding-bottom' => 0,
					'padding-left'   => 0,
					'padding-right'  => 0,
				),
			),
			array(
				'id'       => 'mainmenu-bg-color',
				'type'     => 'color',
				'title'    => __( 'Main Menu Background Color', 'porto' ),
				'subtitle' => __( 'Controls the background color for main menu.', 'porto' ),
				'default'  => 'transparent',
				'validate' => 'color',
			),
			array(
				'id'     => 'desc_info_top_level',
				'type'   => 'info',
				'title'  => __( 'Top Level Menu Item', 'porto' ),
				'notice' => false,
			),
			array(
				'id'             => 'menu-font',
				'type'           => 'typography',
				'title'          => __( 'Menu Font', 'porto' ),
				'subtitle'       => __( 'Controls the typography for main menu\'s first level items.', 'porto' ),
				'google'         => true,
				'subsets'        => false,
				'font-style'     => false,
				'text-align'     => false,
				'color'          => false,
				'letter-spacing' => true,
				'default'        => array(
					'google'         => true,
					'font-weight'    => '700',
					'font-family'    => 'Open Sans',
					'font-size'      => '12px',
					'line-height'    => '20px',
					'letter-spacing' => '0',
				),
				'transport'      => 'refresh',
			),
			array(
				'id'             => 'menu-side-font',
				'type'           => 'typography',
				'title'          => __( 'Side Menu Font', 'porto' ),
				'subtitle'       => __( 'Controls the typography for main sidebar menu\'s first level items.', 'porto' ),
				'google'         => true,
				'subsets'        => false,
				'font-style'     => false,
				'text-align'     => false,
				'color'          => false,
				'letter-spacing' => true,
				'default'        => array(
					'google'         => true,
					'font-weight'    => '400',
					'font-family'    => 'Open Sans',
					'font-size'      => '14px',
					'line-height'    => '18px',
					'letter-spacing' => '0',
				),
				'selector'       => array(
					'node' => '.main-sidebar-menu',
				),
			),
			array(
				'id'       => 'menu-text-transform',
				'type'     => 'button_set',
				'title'    => __( 'Text Transform', 'porto' ),
				'subtitle' => __( 'Controls the text transform for the first level items of main menu and main sidebar menu.', 'porto' ),
				'options'  => array(
					'none'       => __( 'None', 'porto' ),
					'capitalize' => __( 'Capitalize', 'porto' ),
					'uppercase'  => __( 'Uppercase', 'porto' ),
					'lowercase'  => __( 'Lowercase', 'porto' ),
					'initial'    => __( 'Initial', 'porto' ),
				),
				'default'  => 'uppercase',
				'selector' => array(
					'node' => ':root',
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-link-color',
				'type'     => 'link_color',
				'active'   => false,
				'title'    => __( 'Link Color', 'porto' ),
				'subtitle' => __( 'Controls the menu item color for the first level items of main menu and main sidebar menu.', 'porto' ),
				'default'  => array(
					'regular' => '#0088cc',
					'hover'   => '#ffffff',
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-link-color-sticky',
				'type'     => 'link_color',
				'active'   => true,
				'title'    => __( 'Link Color in Sticky Header', 'porto' ),
				'subtitle' => __( 'Controls the menu item color for the first level items of main menu in sticky header.', 'porto' ),
			),
			array(
				'id'       => 'mainmenu-toplevel-hbg-color',
				'type'     => 'color',
				'title'    => __( 'Hover Background Color', 'porto' ),
				'subtitle' => __( 'Controls the background color for the first level items on hover and active.', 'porto' ),
				'default'  => '#0088cc',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-toplevel-config-active',
				'type'     => 'switch',
				'title'    => __( 'Configure Active Color', 'porto' ),
				'subtitle' => __( 'Controls the background and color for the first level active menu items.', 'porto' ),
				'default'  => false,
				'on'       => __( 'Yes', 'porto' ),
				'off'      => __( 'No', 'porto' ),
			),
			array(
				'id'       => 'mainmenu-toplevel-alink-color',
				'type'     => 'color',
				'title'    => __( 'Active Link Color', 'porto' ),
				'required' => array( 'mainmenu-toplevel-config-active', 'equals', true ),
				'default'  => '#ffffff',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-toplevel-abg-color',
				'type'     => 'color',
				'title'    => __( 'Active Background Color', 'porto' ),
				'required' => array( 'mainmenu-toplevel-config-active', 'equals', true ),
				'default'  => '#0088cc',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-toplevel-padding1',
				'type'     => 'spacing',
				'mode'     => 'padding',
				'title'    => __( 'Padding on Desktop', 'porto' ),
				'subtitle' => __( 'Controls the padding for the first level menu items on desktop.', 'porto' ),
				'desc'     => __( 'This is not working for sidebar menus.', 'porto' ),
				'default'  => array(
					'padding-top'    => 10,
					'padding-bottom' => 10,
					'padding-left'   => 16,
					'padding-right'  => 16,
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-padding2',
				'type'     => 'spacing',
				'mode'     => 'padding',
				'title'    => __( 'Padding on Desktop (width > 991px)', 'porto' ),
				'subtitle' => __( 'Controls the padding for the first level menu items on small desktop.', 'porto' ),
				'desc'     => __( 'This is not working for sidebar menus.', 'porto' ),
				'default'  => array(
					'padding-top'    => 9,
					'padding-bottom' => 9,
					'padding-left'   => 14,
					'padding-right'  => 14,
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-padding3',
				'type'     => 'spacing',
				'mode'     => 'padding',
				'title'    => __( 'Padding on Sticky Header (width > 991px)', 'porto' ),
				'subtitle' => __( 'Controls the padding for the first level menu items in sticky header on large displays.', 'porto' ),
				'desc'     => __( 'This is not working for sidebar menus. Please leave blank if you use same values with the ones in default header.', 'porto' ),
			),
			array(
				'id'     => 'desc_info_menu_popup',
				'type'   => 'info',
				'title'  => __( 'Menu Popup', 'porto' ),
				'notice' => false,
			),
			array(
				'id'             => 'menu-popup-font',
				'type'           => 'typography',
				'title'          => __( 'Menu Popup Font', 'porto' ),
				'google'         => true,
				'subsets'        => false,
				'font-style'     => false,
				'text-align'     => false,
				'color'          => false,
				'letter-spacing' => true,
				'default'        => array(
					'google'         => true,
					'font-weight'    => '400',
					'font-family'    => 'Open Sans',
					'font-size'      => '14px',
					'line-height'    => '24px',
					'letter-spacing' => '0',
				),
				'transport'      => 'refresh',
			),
			array(
				'id'      => 'menu-popup-text-transform',
				'type'    => 'button_set',
				'title'   => __( 'Text Transform', 'porto' ),
				'options' => array(
					'none'       => __( 'None', 'porto' ),
					'capitalize' => __( 'Capitalize', 'porto' ),
					'uppercase'  => __( 'Uppercase', 'porto' ),
					'lowercase'  => __( 'Lowercase', 'porto' ),
					'initial'    => __( 'Initial', 'porto' ),
				),
				'default' => 'none',
			),
			array(
				'id'      => 'mainmenu-popup-top-border',
				'type'    => 'border',
				'all'     => false,
				'style'   => false,
				'left'    => false,
				'right'   => false,
				'bottom'  => false,
				'title'   => __( 'Top Border', 'porto' ),
				'default' => $mainmenu_popup_top_border,
			),
			array(
				'id'       => 'mainmenu-popup-bg-color',
				'type'     => 'color',
				'title'    => __( 'Background Color', 'porto' ),
				'default'  => '#ffffff',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-popup-heading-color',
				'type'     => 'color',
				'title'    => __( 'Heading Color', 'porto' ),
				'subtitle' => __( 'Controls the color of sub titles in the mega menu (wide menu).', 'porto' ),
				'default'  => '#333333',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-popup-text-color',
				'type'     => 'link_color',
				'active'   => false,
				'title'    => __( 'Link Color', 'porto' ),
				'default'  => array(
					'regular' => '#777777',
					'hover'   => '#777777',
				),
				'selector' => array(
					'node' => 'li.menu-item, .sub-menu',
				),
			),
			array(
				'id'       => 'mainmenu-popup-text-hbg-color',
				'type'     => 'color',
				'title'    => __( 'Link Hover Background Color', 'porto' ),
				'default'  => '#f4f4f4',
				'validate' => 'color',
				'selector' => array(
					'node' => 'li.menu-item',
				),
			),
			array(
				'id'       => 'mainmenu-popup-narrow-type',
				'type'     => 'button_set',
				'title'    => __( 'Narrow Menu Style', 'porto' ),
				'subtitle' => __( 'Controls the background color style for the narrow sub menus (menu popup).', 'porto' ),
				'desc'     => __( 'If you select "With Top Menu Hover Bg Color", please insert hover background color for the first level items in the "Top Level Menu Item / Hover Background Color".', 'porto' ),
				'options'  => array(
					''  => __( 'With Popup BG Color', 'porto' ),
					'1' => __( 'With Top Menu Hover Bg Color', 'porto' ),
				),
				'default'  => '',
			),
			array(
				'id'     => 'desc_info_tip',
				'type'   => 'info',
				'title'  => __( 'Tip', 'porto' ),
				'notice' => false,
			),
			array(
				'id'       => 'mainmenu-tip-bg-color',
				'type'     => 'color',
				'title'    => __( 'Tip Background Color', 'porto' ),
				'subtitle' => __( 'Controls the background color for the tip labels in the main menu item.', 'porto' ),
				'default'  => '#0cc485',
				'validate' => 'color',
			),
			array(
				'id'     => 'desc_info_menu_custom',
				'type'   => 'info',
				'title'  => __( 'Menu Custom Content (if header type is 1, 3, 4, 9, 13, 14 or header builder)', 'porto' ),
				'notice' => false,
			),
			array(
				'id'       => 'menu-custom-text-color',
				'type'     => 'color',
				'title'    => __( 'Text Color', 'porto' ),
				'subtitle' => __( 'Controls the text color for the menu custom content which is inserted in Header / Menu Custom Content', 'porto' ),
				'default'  => '#777777',
				'validate' => 'color',
			),
			array(
				'id'       => 'menu-custom-link',
				'type'     => 'link_color',
				'title'    => __( 'Link Color', 'porto' ),
				'subtitle' => __( 'Controls the color of A tag for the menu custom content which is inserted in Header / Menu Custom Content', 'porto' ),
				'active'   => false,
				'default'  => array(
					'regular' => '#0088cc',
					'hover'   => '#006fa4',
				),
			),
		),
	);
} else {
	$this->sections[] = array(
		'id'         => 'skin-main-menu',
		'icon_class' => 'icon',
		'subsection' => true,
		'title'      => __( 'Menu Styling', 'porto' ),
		'transport'  => 'postMessage',
		'fields'     => array(
			array(
				'id'     => 'desc_info_top_level',
				'type'   => 'info',
				'title'  => __( 'Top Level Menu Item', 'porto' ),
				'notice' => false,
			),
			array(
				'id'             => 'menu-font',
				'type'           => 'typography',
				'title'          => __( 'Menu Font', 'porto' ),
				'subtitle'       => __( 'Controls the typography for main menu\'s first level items.', 'porto' ),
				'google'         => true,
				'subsets'        => false,
				'font-style'     => false,
				'text-align'     => false,
				'color'          => false,
				'letter-spacing' => true,
				'default'        => array(
					'google'         => true,
					'font-weight'    => '700',
					'font-family'    => 'Open Sans',
					'font-size'      => '12px',
					'line-height'    => '20px',
					'letter-spacing' => '0',
				),
				'transport'      => 'refresh',
			),
			array(
				'id'             => 'menu-side-font',
				'type'           => 'typography',
				'title'          => __( 'Side Menu Font', 'porto' ),
				'subtitle'       => __( 'Controls the typography for main sidebar menu\'s first level items.', 'porto' ),
				'google'         => true,
				'subsets'        => false,
				'font-style'     => false,
				'text-align'     => false,
				'color'          => false,
				'letter-spacing' => true,
				'default'        => array(
					'google'         => true,
					'font-weight'    => '400',
					'font-family'    => 'Open Sans',
					'font-size'      => '14px',
					'line-height'    => '18px',
					'letter-spacing' => '0',
				),
				'transport'      => 'refresh',
				'selector'       => array(
					'node' => '.main-sidebar-menu',
				),
			),
			array(
				'id'       => 'menu-text-transform',
				'type'     => 'button_set',
				'title'    => __( 'Text Transform', 'porto' ),
				'subtitle' => __( 'Controls the text transform for the first level items of main menu and main sidebar menu.', 'porto' ),
				'options'  => array(
					'none'       => __( 'None', 'porto' ),
					'capitalize' => __( 'Capitalize', 'porto' ),
					'uppercase'  => __( 'Uppercase', 'porto' ),
					'lowercase'  => __( 'Lowercase', 'porto' ),
					'initial'    => __( 'Initial', 'porto' ),
				),
				'default'  => 'uppercase',
				'selector' => array(
					'node' => ':root',
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-link-color',
				'type'     => 'link_color',
				'active'   => false,
				'title'    => __( 'Link Color', 'porto' ),
				'subtitle' => __( 'Controls the menu item color for the first level items of main menu and main sidebar menu.', 'porto' ),
				'default'  => array(
					'regular' => '#0088cc',
					'hover'   => '#ffffff',
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-link-color-sticky',
				'type'     => 'link_color',
				'active'   => true,
				'title'    => __( 'Link Color in Sticky Header', 'porto' ),
				'subtitle' => __( 'Controls the menu item color for the first level items of main menu in sticky header.', 'porto' ),
			),
			array(
				'id'       => 'mainmenu-toplevel-hbg-color',
				'type'     => 'color',
				'title'    => __( 'Hover Background Color', 'porto' ),
				'subtitle' => __( 'Controls the background color for the first level items on hover and active.', 'porto' ),
				'default'  => '#0088cc',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-toplevel-config-active',
				'type'     => 'switch',
				'title'    => __( 'Configure Active Color', 'porto' ),
				'subtitle' => __( 'Controls the background and color for the first level active menu items.', 'porto' ),
				'default'  => false,
				'on'       => __( 'Yes', 'porto' ),
				'off'      => __( 'No', 'porto' ),
			),
			array(
				'id'       => 'mainmenu-toplevel-alink-color',
				'type'     => 'color',
				'title'    => __( 'Active Link Color', 'porto' ),
				'required' => array( 'mainmenu-toplevel-config-active', 'equals', true ),
				'default'  => '#ffffff',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-toplevel-abg-color',
				'type'     => 'color',
				'title'    => __( 'Active Background Color', 'porto' ),
				'required' => array( 'mainmenu-toplevel-config-active', 'equals', true ),
				'default'  => '#0088cc',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-toplevel-padding1',
				'type'     => 'spacing',
				'mode'     => 'padding',
				'title'    => __( 'Padding on Desktop', 'porto' ),
				'subtitle' => __( 'Controls the padding for the first level menu items on desktop.', 'porto' ),
				'desc'     => __( 'This is not working for sidebar menus.', 'porto' ),
				'default'  => array(
					'padding-top'    => 10,
					'padding-bottom' => 10,
					'padding-left'   => 16,
					'padding-right'  => 16,
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-padding2',
				'type'     => 'spacing',
				'mode'     => 'padding',
				'title'    => __( 'Padding on Desktop (width > 991px)', 'porto' ),
				'subtitle' => __( 'Controls the padding for the first level menu items on small desktop.', 'porto' ),
				'desc'     => __( 'This is not working for sidebar menus.', 'porto' ),
				'default'  => array(
					'padding-top'    => 9,
					'padding-bottom' => 9,
					'padding-left'   => 14,
					'padding-right'  => 14,
				),
			),
			array(
				'id'       => 'mainmenu-toplevel-padding3',
				'type'     => 'spacing',
				'mode'     => 'padding',
				'title'    => __( 'Padding on Sticky Header (width > 991px)', 'porto' ),
				'subtitle' => __( 'Controls the padding for the first level menu items in sticky header on large displays.', 'porto' ),
				'desc'     => __( 'This is not working for sidebar menus. Please leave blank if you use same values with the ones in default header.', 'porto' ),
			),
			array(
				'id'     => 'desc_info_menu_popup',
				'type'   => 'info',
				'title'  => __( 'Menu Popup', 'porto' ),
				'notice' => false,
			),
			array(
				'id'             => 'menu-popup-font',
				'type'           => 'typography',
				'title'          => __( 'Menu Popup Font', 'porto' ),
				'google'         => true,
				'subsets'        => false,
				'font-style'     => false,
				'text-align'     => false,
				'color'          => false,
				'letter-spacing' => true,
				'default'        => array(
					'google'         => true,
					'font-weight'    => '400',
					'font-family'    => 'Open Sans',
					'font-size'      => '14px',
					'line-height'    => '24px',
					'letter-spacing' => '0',
				),
				'transport'      => 'refresh',
			),
			array(
				'id'      => 'menu-popup-text-transform',
				'type'    => 'button_set',
				'title'   => __( 'Text Transform', 'porto' ),
				'options' => array(
					'none'       => __( 'None', 'porto' ),
					'capitalize' => __( 'Capitalize', 'porto' ),
					'uppercase'  => __( 'Uppercase', 'porto' ),
					'lowercase'  => __( 'Lowercase', 'porto' ),
					'initial'    => __( 'Initial', 'porto' ),
				),
				'default' => 'none',
			),
			array(
				'id'      => 'mainmenu-popup-top-border',
				'type'    => 'border',
				'all'     => false,
				'style'   => false,
				'left'    => false,
				'right'   => false,
				'bottom'  => false,
				'title'   => __( 'Top Border', 'porto' ),
				'default' => $mainmenu_popup_top_border,
			),
			array(
				'id'       => 'mainmenu-popup-bg-color',
				'type'     => 'color',
				'title'    => __( 'Background Color', 'porto' ),
				'default'  => '#ffffff',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-popup-heading-color',
				'type'     => 'color',
				'title'    => __( 'Heading Color', 'porto' ),
				'subtitle' => __( 'Controls the color of sub titles in the mega menu (wide menu).', 'porto' ),
				'default'  => '#333333',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-popup-text-color',
				'type'     => 'link_color',
				'active'   => false,
				'title'    => __( 'Link Color', 'porto' ),
				'default'  => array(
					'regular' => '#777777',
					'hover'   => '#777777',
				),
				'selector' => array(
					'node' => 'li.menu-item, .sub-menu',
				),
			),
			array(
				'id'       => 'mainmenu-popup-text-hbg-color',
				'type'     => 'color',
				'title'    => __( 'Link Hover Background Color', 'porto' ),
				'default'  => '#f4f4f4',
				'validate' => 'color',
			),
			array(
				'id'       => 'mainmenu-popup-narrow-type',
				'type'     => 'button_set',
				'title'    => __( 'Narrow Menu Style', 'porto' ),
				'subtitle' => __( 'Controls the background color style for the narrow sub menus (menu popup).', 'porto' ),
				'desc'     => __( 'If you select "With Top Menu Hover Bg Color", please insert hover background color for the first level items in the "Top Level Menu Item / Hover Background Color".', 'porto' ),
				'options'  => array(
					''  => __( 'With Popup BG Color', 'porto' ),
					'1' => __( 'With Top Menu Hover Bg Color', 'porto' ),
				),
				'default'  => '',
			),
			array(
				'id'     => 'desc_info_tip',
				'type'   => 'info',
				'title'  => __( 'Tip', 'porto' ),
				'notice' => false,
			),
			array(
				'id'       => 'mainmenu-tip-bg-color',
				'type'     => 'color',
				'title'    => __( 'Tip Background Color', 'porto' ),
				'subtitle' => __( 'Controls the background color for the tip labels in the main menu item.', 'porto' ),
				'default'  => '#0cc485',
				'validate' => 'color',
			),
		),
	);
}

$this->sections[] = array(
	'id'         => 'mobile-panel-settings',
	'icon_class' => 'icon',
	'subsection' => true,
	'title'      => __( 'Mobile Menu', 'porto' ),
	'fields'     => array(
		array(
			'id'      => 'mobile-panel-type',
			'type'    => 'image_select',
			'title'   => __( 'Mobile Panel Type', 'porto' ),
			'desc'    => __( 'Controls the panel type of mobile toggle menu.', 'porto' ),
			'options' => array(
				''     => array(
					'title' => __( 'Default', 'porto' ),
					'img'   => PORTO_OPTIONS_URI . '/svg/mobile-default.svg',
				),
				'side' => array(
					'title' => __( 'Side Navigation', 'porto' ),
					'img'   => PORTO_OPTIONS_URI . '/svg/mobile-side.svg',
				),
				'none' => array(
					'title' => __( 'None', 'porto' ),
					'img'   => PORTO_OPTIONS_URI . '/svg/none.svg',
				),
			),
			'default' => '',
		),
		array(
			'id'        => 'mobile-panel-pos',
			'type'      => 'button_set',
			'title'     => __( 'Position', 'porto' ),
			'desc'      => __( 'Controls the position of mobile offcanvas menu.', 'porto' ),
			'options'   => array(
				''            => __( 'Default', 'porto' ),
				'panel-left'  => __( 'Left', 'porto' ),
				'panel-right' => __( 'Right', 'porto' ),
			),
			'default'   => '',
			'required'  => array( 'mobile-panel-type', 'equals', array( 'side' ) ),
			'transport' => 'postMessage',
		),
		array(
			'id'        => 'mobile-panel-add-switcher',
			'type'      => 'switch',
			'title'     => __( 'Add Language, Currency Switcher', 'porto' ),
			'desc'      => sprintf( __( 'Determines whether to put the switchers in the mobile menu. You should enable %1$sHeader/Language,Currency Switcher%2$s', 'porto' ), '<b>', '</b>' ),
			'required'  => array( 'mobile-panel-type', 'equals', array( '', 'side' ) ),
			'default'   => false,
			'on'        => __( 'Yes', 'porto' ),
			'off'       => __( 'No', 'porto' ),
			'transport' => 'postMessage',
		),
		array(
			'id'        => 'mobile-panel-add-search',
			'type'      => 'switch',
			'title'     => __( 'Add Search Box', 'porto' ),
			'desc'      => __( 'Determines whether to put a search box in the mobile menu.', 'porto' ),
			'required'  => array( 'mobile-panel-type', 'equals', array( 'side' ) ),
			'default'   => false,
			'on'        => __( 'Yes', 'porto' ),
			'off'       => __( 'No', 'porto' ),
			'transport' => 'postMessage',
		),
		array(
			'id'       => 'desc_info_mobile_menu_location',
			'type'     => 'info',
			'title'    => __( 'Display Mobile Menus', 'porto' ),
			'notice'   => false,
			'required' => array( 'mobile-panel-type', 'contains', 'side' ),
		),
		array(
			'id'       => 'show-mobile-menus',
			'type'     => 'button_set',
			'title'    => __( 'Select menus to display on mobile', 'porto' ),
			'desc'     => __( 'This will show menus on the top of the mobile menu as tab title.', 'porto' ),
			'multi'    => true,
			'options'  => array(
				'main'       => __( 'Main Menu', 'porto' ),
				'secondary'  => __( 'Secondary Menu', 'porto' ),
				'side'       => __( 'Sidebar Menu', 'porto' ),
				'navigation' => __( 'Top Navigation', 'porto' ),
			),
			'default'  => array( 'main', 'navigation' ),
			'required' => array( 'mobile-panel-type', 'contains', 'side' ),
		),
		array(
			'id'       => 'menu-main',
			'type'     => 'text',
			'title'    => __( 'Tab Title for Main Menu', 'porto' ),
			'default'  => __( 'Main Menu', 'porto' ),
			'required' => array( 'show-mobile-menus', 'contains', 'main' ),
		),
		array(
			'id'       => 'menu-secondary',
			'type'     => 'text',
			'title'    => __( 'Tab Title for Secondary Menu', 'porto' ),
			'default'  => __( 'Secondary Menu', 'porto' ),
			'required' => array( 'show-mobile-menus', 'contains', 'secondary' ),
		),
		array(
			'id'       => 'menu-side',
			'type'     => 'text',
			'title'    => __( 'Tab Title for Sidebar Menu', 'porto' ),
			'default'  => __( 'Sidebar Menu', 'porto' ),
			'required' => array( 'show-mobile-menus', 'contains', 'side' ),
		),
		array(
			'id'       => 'menu-navigation',
			'type'     => 'text',
			'title'    => __( 'Tab Title for Top Navigation', 'porto' ),
			'default'  => __( 'Top Navigation', 'porto' ),
			'required' => array( 'show-mobile-menus', 'contains', 'navigation' ),
		),
		array(
			'id'     => 'desc_info_mobile_menu_toggle',
			'type'   => 'info',
			'title'  => __( 'Mobile Menu Toggle', 'porto' ),
			'notice' => false,
		),
		array(
			'id'       => 'mobile-menu-toggle-text-color',
			'type'     => 'color',
			'title'    => __( 'Toggle Icon Color', 'porto' ),
			'desc'     => __( 'Controls the color of mobile toggle icon.', 'porto' ),
			'default'  => '#fff',
			'validate' => 'color',
		),
		array(
			'id'       => 'mobile-menu-toggle-bg-color',
			'type'     => 'color',
			'title'    => __( 'Background Color', 'porto' ),
			'desc'     => __( 'Controls the background color of mobile toggle icon.', 'porto' ),
			'validate' => 'color',
		),
		array(
			'id'     => 'desc_info_mobile_menu_panel',
			'type'   => 'info',
			'title'  => __( 'Mobile Menu Panel', 'porto' ),
			'notice' => false,
		),
		array(
			'id'       => 'panel-bg-color',
			'type'     => 'color',
			'title'    => __( 'Background Color', 'porto' ),
			'desc'     => __( 'Controls the background color of mobile offcanvas or dropdown.', 'porto' ),
			'validate' => 'color',
			'default'  => '#ffffff',
		),
		array(
			'id'       => 'panel-border-color',
			'type'     => 'color',
			'title'    => __( 'Border Color', 'porto' ),
			'desc'     => __( 'Controls the divider color of mobile offcanvas or dropdown.', 'porto' ),
			'default'  => '#e8e8e8',
			'validate' => 'color',
		),
		array(
			'id'       => 'panel-link-hbgcolor',
			'type'     => 'color',
			'title'    => __( 'Hover Background Color', 'porto' ),
			'desc'     => __( 'Controls the hover / active background color of mobile menu item.', 'porto' ),
			'default'  => '',
			'validate' => 'color',
		),
		array(
			'id'       => 'panel-text-color',
			'type'     => 'color',
			'title'    => __( 'Text Color', 'porto' ),
			'desc'     => __( 'Controls the text color in mobile panel.', 'porto' ),
			'default'  => '',
			'validate' => 'color',
		),
		array(
			'id'      => 'panel-link-color',
			'type'    => 'link_color',
			'active'  => false,
			'title'   => __( 'Link Color', 'porto' ),
			'desc'    => __( 'Controls the link color in mobile panel.', 'porto' ),
			'default' => array(
				'regular' => '',
				'hover'   => '',
			),
		),
	),
);

if ( class_exists( 'WooCommerce' ) ) {
	$this->sections[] = array(
		'id'         => 'mobile-sticky-bar',
		'icon_class' => 'icon',
		'subsection' => true,
		'title'      => __( 'Mobile Bottom Sticky Bar', 'porto' ),
		'fields'     => array(
			array(
				'id'      => 'show-icon-menus-mobile',
				'type'    => 'button_set',
				'title'   => __( 'Show Sticky Icon Menu bar on mobile', 'porto' ),
				'desc'    => __( 'This will show sticky icon menu bar at the bottom of the page on mobile.', 'porto' ),
				'multi'   => true,
				'options' => array(
					'home'     => __( 'Home', 'porto' ),
					'blog'     => __( 'Blog', 'porto' ),
					'shop'     => __( 'Shop', 'porto' ),
					'wishlist' => __( 'Wishlist', 'porto' ),
					'account'  => __( 'Account', 'porto' ),
					'cart'     => __( 'Cart', 'porto' ),
				),
				'default' => array(),
			),
			array(
				'id'       => 'sticky-icon-home',
				'type'     => 'text',
				'title'    => __( 'Home Icon', 'porto' ),
				'default'  => __( 'porto-icon-category-home', 'porto' ),
				'required' => array( 'show-icon-menus-mobile', 'contains', 'home' ),
			),
			array(
				'id'       => 'sticky-icon-blog',
				'type'     => 'text',
				'title'    => __( 'Blog Icon', 'porto' ),
				'default'  => __( 'far fa-calendar-alt', 'porto' ),
				'required' => array( 'show-icon-menus-mobile', 'contains', 'blog' ),
			),
			array(
				'id'       => 'sticky-icon-shop',
				'type'     => 'text',
				'title'    => __( 'Shop Icon', 'porto' ),
				'default'  => __( 'porto-icon-bars', 'porto' ),
				'required' => array( 'show-icon-menus-mobile', 'contains', 'shop' ),
			),
			array(
				'id'       => 'sticky-icon-wishlist',
				'type'     => 'text',
				'title'    => __( 'Wishlist Icon', 'porto' ),
				'default'  => __( 'porto-icon-wishlist-2', 'porto' ),
				'required' => array( 'show-icon-menus-mobile', 'contains', 'wishlist' ),
			),
			array(
				'id'       => 'sticky-icon-account',
				'type'     => 'text',
				'title'    => __( 'Account Icon', 'porto' ),
				'default'  => __( 'porto-icon-user-2', 'porto' ),
				'required' => array( 'show-icon-menus-mobile', 'contains', 'account' ),
			),
			array(
				'id'       => 'sticky-icon-cart',
				'type'     => 'text',
				'title'    => __( 'Cart Icon', 'porto' ),
				'default'  => __( 'porto-icon-shopping-cart', 'porto' ),
				'required' => array( 'show-icon-menus-mobile', 'contains', 'cart' ),
			),
		),
	);
}
